<template>
    <div class="bottom__table">
        <div class="table__title animated fadeInUp">
            <p class="title-table">{{ $t('deposits.table.title') }}</p>
            <select-wrapper v-slot="slotProps" :options="sort_options" :value="current_sort" :opened="sort_opened">
                <div class="block-sort box-sortirovka" @click="sort_opened = !sort_opened">
                    <div class="headSort">
                        <p class="text-sort">{{ $t('deposits.table.sort_by') }}</p>
                        <p id="sort" class="text-sortBlue">{{ slotProps.current_label }}</p>
                        <svg class="down" :style="slotProps.arrowStyle">
                            <use xlink:href="/img/sprite.svg#right-arrow-circular-button"/>
                        </svg>
                    </div>
                    <transition name="slide">
                        <div class="bodySort" v-if="sort_opened">
                            <p class="text-login" v-for="(label, key) in slotProps.options" @click="current_sort = key">{{ label }}</p>
                        </div>
                    </transition>
                </div>
            </select-wrapper>
        </div>
        <table>
            <thead>
            <tr>
                <th>{{ $t('deposits.table.id') }}</th>
                <th>{{ $t('deposits.table.date') }}</th>
                <th>{{ $t('deposits.table.login') }}</th>
                <th>{{ $t('deposits.table.amount') }}</th>
                <th>{{ $t('deposits.table.plan') }}</th>
                <th/>
            </tr>
            </thead>
            <tbody>
            <template v-for="deposit in deposits" v-if="deposit.id">
                <deposit :deposit="deposit" :key="deposit.id"/>
                <tr class="noneTable"/>
            </template>
            </tbody>
        </table>
        <paginator
            :current-page="currentPage"
            :last-page="lastPage"
            :per-page="perPage"
            :items-count="total"
            @page-changed="setPage"
        />
    </div>
</template>

<script>
    import _ from 'lodash';
    import { mapGetters } from 'vuex';
    import Deposit from "./Deposit";

	export default {
		name: "DepositsTable",
        props: [],
        data(){
            return {
                currentPage: 0,
                lastPage: 0,
                perPage: 0,
                total: 0,
                page: 1,
                current_sort: 'id',
                deposits: [],
                sort_opened: false,
                sort_options: {
                    'id':       this.$t('deposits.table.sorts.id'),
                    'date':     this.$t('deposits.table.sorts.date'),
                    'login':    this.$t('deposits.table.sorts.login'),
                    'amount':   this.$t('deposits.table.sorts.amount'),
                    'plan':     this.$t('deposits.table.sorts.plan'),
                },
            }
        },
        computed: {
            ...mapGetters([
                'axios'
            ])
        },
        watch: {
            current_sort(sort){
                this.submit();
            },
        },
        methods: {
            submit(){
                this.axios
                    .get('deposits', {
                        params: {
                            sort_by: this.current_sort,
                            page: this.page
                        }
                    })
                    .then(resp => resp.data)
                    .then(deposits => {
                        console.log(deposits);
                        this.currentPage = deposits.current_page;
                        this.lastPage = deposits.last_page;
                        this.perPage = deposits.per_page;
                        this.total = deposits.total;
                        this.deposits = deposits.data;
                    });
            },
            setPage(page){
                this.page = page;
                this.submit();
            },
        },
        components: {
		    Deposit
        },
        created(){
		    this.submit();
        }
	}
</script>

<style scoped>

    .slide-enter-active,
    .slide-leave-active {
        transition: max-height 1s ease;
    }
    .slide-enter,
    .slide-leave-to {
        max-height: 0px;
    }
</style>
